
/*  -*- MaTX -*-
 *
 *  ̾
 *      corrcoef_col() - ط(Υǡ)
 *
 *  ڷ
 *      C = corrcoef_col(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = corrcoef_col(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  ڵǽ
 *      X ٥ȥΤȤcorrcoef_col(X) X ʬط 1 ֤
 *      X ΤȤcorrcoef_col(X) ϡX ˥ǡ¸
 *      ȸʤط롣
 *
 *      corrcoef_col(X,Y) ϡX  Y ƱĹΥ٥ȥʤ顤
 *      corrcoef_col([makecolv(X) makecolv(Y)])Ǥ롣
 *
 *  
 *      >> C = corrcoef_col([1 2 3 4 5])
 *      === [C] : (  1,  1) ===
 *                (  1)     
 *      (  1)  1.00000000E+00
 *
 *      >> C = corrcoef_col([2 3 1 4 5], [10 9 7 8 6])
 *      === [C] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  1.41421355E+00 -5.65685428E-01
 *      (  2) -5.65685428E-01  1.41421355E+00
 *
 *  ڴϢܡ
 *      sum, median, mean, corrcoef_row
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      corrcoef_row() - ط(Υǡ)
 *
 *  ڷ
 *      C = corrcoef_row(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = corrcoef_row(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  ڵǽ
 *      X ٥ȥΤȤcorrcoef_row(X) X ʬط 1 ֤
 *      X ΤȤcorrcoef_row(X) ϡX ι˥ǡ¸
 *      ȸʤط롣
 *
 *      corrcoef_row(X,Y) ϡX  Y ƱĹΥ٥ȥʤ顤
 *      corrcoef_row([[makerowv(X)][makerowv(Y)]])Ǥ롣
 *
 *  
 *      >> C = corrcoef_row([1 2 3 4 5])
 *      === [C] : (  1,  1) ===
 *                (  1)     
 *      (  1)  1.00000000E+00
 *
 *      >> C = corrcoef_row([2 3 1 4 5], [10 9 7 8 6])
 *      === [C] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  1.41421355E+00 -5.65685428E-01
 *      (  2) -5.65685428E-01  1.41421355E+00
 *
 *  ڴϢܡ
 *      sum, median, mean, corrcoef_col
 */


Func Array corrcoef_col(x, y, ...)
	Array x, y;
{
	Array cc;
	Matrix dv, cv;

	error(nargchk(1, 2, nargs, "corrcoef_col"));

	if (nargs == 1) {
		cv = cov_col(x);
	} else if (nargs == 2) {
		cv = cov_col(x, y);
	}

	dv = diag_vec(cv);
	cc = Array(cv) / sqrt(Array(dv*dv#));
	return cc;
}

Func Array corrcoef_row(x, y, ...)
	Array x, y;
{
	error(nargchk(1, 2, nargs, "corrcoef_row"));
	
	if (nargs == 1) {
		return trans(corrcoef_col(trans(x)));
	} else {
		return trans(corrcoef_col(trans(x), trans(y)));
	}
}



