
/*  -*- MaTX -*-
 *
 *  ̾
 *      cov() - ʬ
 *
 *  ڷ
 *      C = cov(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = cov(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  ڵǽ
 *      cov(X) X Ƥʬʬ֤
 *      cov(X,Y) Ϲ [X Y] ʬ֤
 *
 *  
 *      >> cov([1 2 3 4 5])
 *      ans = 2.5
 *      >> cov([1 2 3 4 5], [6 7 8 9 10])
 *      ans = 9.16667
 *
 *  ڴϢܡ
 *      sum, median, mean, cov_row, cov_col
 *
 *   -----------------------------------------------------------------------
 *
 *  ̾
 *      cov_col() - ʬ(Υǡ)
 *
 *  ڷ
 *      C = cov_col(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = cov_col(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  ڵǽ
 *      X ٥ȥΤȤcov_col(X) X Ƥʬʬ֤
 *      X ΤȤcov_col(X) ϡX ˥ǡ¸
 *      ȸʤʬ롣
 *
 *      cov_col(X,Y) ϡX  Y ƱĹΥ٥ȥʤ顤
 *      cov_col([makecolv(X) makecolv(Y)])Ǥ롣
 *
 *  
 *      >> C = cov_col([1 2 3 4 5])
 *      ===  C  (   1  x   1)  Matrix  ===
 *                 (  1)     
 *      (  1)  2.50000000E+00
 *      >> C = cov_col([2 3 1 4 5], [10 9 7 8 6])
 *      === [C] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  2.50000000E+00 -1.00000000E+00
 *      (  2) -1.00000000E+00  2.50000000E+00
 *
 *  ڴϢܡ
 *      sum, median, mean, cov, cov_row
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      cov_row() - ʬ(Υǡ)
 *
 *  ڷ
 *      C = cov_row(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = cov_row(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  ڵǽ
 *      X ٥ȥΤȤcov_row(X) X Ƥʬʬ֤
 *      X ΤȤcov_row(X) ϡX ι˥ǡ¸
 *      ȸʤʬ롣
 *
 *      cov_row(X,Y) ϡX  Y ƱĹΥ٥ȥʤ顤
 *      cov_row([[makerowv(X)][makerowv(Y)]])Ǥ롣
 *
 *  
 *      >> C = cov_row([1 2 3 4 5])
 *      ===  C  (   1  x   1)  Matrix  ===
 *                 (  1)     
 *      (  1)  2.50000000E+00
 *      >> C = cov_row([2 3 1 4 5], [10 9 7 8 6])
 *      ===  C  (   2  x   2)  Matrix  ===
 *                 (  1)           (  2)     
 *      (  1)  2.50000000E+00 -1.00000000E+00
 *      (  2) -1.00000000E+00  2.50000000E+00
 *
 *  ڴϢܡ
 *      sum, median, mean, cov, cov_col
 */


Func Real cov(x, y, ...)
	Matrix x, y;
{
	Matrix z;

	error(nargchk(1, 2, nargs, "cov"));
	
	if (nargs == 1) {
		return [cov_col(reshape(x, 1, Rows(x)*Cols(x)))](1,1);
	} else {
		z = [makecolv(x), makecolv(y)];
		return [cov_col(reshape(z, 1, Rows(z)*Cols(z)))](1,1);
	}
}

Func Matrix cov_col(x_, y_, ...)
	Matrix x_, y_;
{
	Integer m, n;
	Matrix X, cv;

	error(nargchk(1, 2, nargs, "cov_col"));

	{m,n} = size(x_);

	if (nargs > 1) {
		if (m != Rows(y_) || n != Cols(y_)) {
			error("cov_col(): X  Y Ʊ礭ǤʤФʤ餤\n");
		}
		if (m != 1 && n != 1) {
			error("cov_col(): X  Y ϥ٥ȥǤʤФʤ餤\n");
		}
		X = [makecolv(x_), makecolv(y_)];
	} else if (min(Cols(x_), Rows(x_)) == 1) {
		X = makecolv(x_);
	} else {
		X = x_;
	}

	m = Rows(X);
	X = X - ONE(m,1) * (sum_col(X)/m);

	if (m == 1) {
		cv = Z(1);
	} else {
		cv = X#*X / (m-1);
	}
	return cv;
}

Func Matrix cov_row(x, y, ...)
	Matrix x, y;
{
	error(nargchk(1, 2, nargs, "cov_row"));
	
	if (nargs == 1) {
		return trans(cov_col(trans(x)));
	} else {
		return trans(cov_col(x, y));
	}
}
