
/*  -*- MaTX -*-
 *
 *  ̾
 *      diff() - ʬ
 *
 *  ڷ
 *      Y = diff(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  ڵǽ
 *      ٥ȥ X ˤƤĤơdiff(X)ϡʬȤκʬʬȤ
 *      ٥ȥ
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      롣٥ȥ Y Ĺϥ٥ȥ X Ĺ 1 ʬ
 *      ʤʤ롣diff(X,k) ϡk ʬ롣
 *
 *          diff(X,k) = diff(diff(X,n-1))
 *
 *  
 *      >> Y = diff([1 2 3 4 5]) 
 *      === [Y] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *  ڴϢܡ
 *      diff_row, diff_col
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      diff_col() - κʬ
 *
 *  ڷ
 *      Y = diff_col(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff_col(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  ڵǽ
 *      X ٥ȥΤȤdiff_col(X)ϡʬȤκʬʬȤ
 *      ٥ȥ
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      롣٥ȥ Y Ĺϥ٥ȥ X Ĺ 1 ʬ
 *      ʤʤ롣diff_col(X,k) ϡk ʬ롣
 *
 *          diff_col(X,k) = diff_col(diff_col(X,n-1))
 *
 *      X ΤȤY = diff_col(X) ϡX ˺ʬ롣
 *       Y ιԤοϡ X ιԤο 1 ʤ
 *
 *  
 *      >> C = diff_col([1 2 3 4 5])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *      >> C = diff_col([[2 3 1 4][10 9 7 8]])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  8.000000E+00  6.000000E+00  6.000000E+00  4.000000E+00
 *
 *  ڴϢܡ
 *      diff, diff_row
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      diff_row() - κʬ
 *
 *  ڷ
 *      Y = diff_row(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      Y = diff_row(X,k)
 *         Matrix Y;
 *         Matrix X;
 *         Integer k;
 *
 *  ڵǽ
 *      X ٥ȥΤȤdiff_row(X)ϡʬȤκʬʬȤ
 *      ٥ȥ
 *      
 *          Y = X(2:length(X)) - X(1:length(x)-1)
 *
 *      롣٥ȥ Y Ĺϥ٥ȥ X Ĺ 1 ʬ
 *      ʤʤ롣diff_row(X,k) ϡk ʬ롣
 *
 *          diff_row(X,k) = diff_row(diff_row(X,n-1))
 *
 *      X ΤȤY = diff_row(X) ϡX ι˺ʬ롣
 *       Y οϡ X ο 1 ʤ
 *
 *  
 *      >> C = diff_row([1 2 3 4 5])
 *      === [C] : (  1,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00  1.000000E+00  1.000000E+00  1.000000E+00
 *
 *      >> C = diff_row([[2 3 1 4 5][10 9 7 8 6]])
 *      === [C] : (  2,  4) ===
 *                 (  1)         (  2)         (  3)         (  4)     
 *      (  1)  1.000000E+00 -2.000000E+00  3.000000E+00  1.000000E+00
 *      (  2) -1.000000E+00 -2.000000E+00  1.000000E+00 -2.000000E+00
 *
 *  ڴϢܡ
 *      diff, diff_col
 */

Func Matrix diff(x, k, ...)
	Matrix x;
	Integer k;
{
	Matrix y;

	error(nargchk(1, 2, nargs, "diff"));
	
	if (nargs == 1) {
		if (Rows(x) == 1 || Cols(x) == 1) {
			return diff_col(x);
		} else {
			error("diff(): ٥ȥǤʤ\n");
		}
	} else {
		if (Rows(x) == 1 || Cols(x) == 1) {
			return diff_col(x, k);
		} else {
			error("diff(): ٥ȥǤʤ\n");
		}
	}
}

Func Matrix diff_col(x_, k, ...)
	Matrix x_;
	Integer k;
{
	Matrix x;
	Integer i,m,n;

	error(nargchk(1, 2, nargs, "diff_col"));

	x = x_;

	if (nargs == 1) {
		k = 1;
	}
	for (i = 1; i <= k; i++) {
		{m,n} = size(x);
		if (m == 1) {
			x = x(2:n) - x(1:n-1);
		} else {
			x = x(2:m,:) - x(1:m-1,:);
		}
	}
	return x;
}

Func Matrix diff_row(x, k, ...)
	Matrix x;
	Integer k;
{
	error(nargchk(1, 2, nargs, "diff_row"));
	
	if (nargs == 1) {
		return trans(diff_col(trans(x)));
	} else {
		return trans(diff_col(trans(x), k));
	}
}
