
/*  -*- MaTX -*-
 *
 *  ̾
 *      median() - Ƥʬ
 *
 *  ڷ
 *      x = median(X)
 *         (Real  |Complex |Polynomial|Rational) x;
 *         (Matrix|CoMatrix|PoMatrix  |RaMatrix) X;
 *
 *      x = median(X)
 *         (Real |Complex|Polynomial|Rational) x
 *         (Array|CoArray|PoArray   |RaArray ) X;
 *
 *      x = median(X)
 *         Integer x;
 *         Index X;
 *
 *  ڵǽ
 *      median(X)ϡƤʬͤ롣
 *
 *  
 *      >> median([1 2 3 4 5])
 *      asn = 3
 *
 *  ڴϢܡ
 *      sum, std, mean, median_row, median_col
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      median_col() - ʬ
 *
 *  ڷ
 *      Y = median_col(X)
 *         (Matrix|Array|Index) Y;
 *         (Matrix|Array|Index) X;
 *
 *  ڵǽ
 *      median_col(X)ϡʬͤᡤԥ٥ȥ֤
 *
 *      X ٥ȥޤϹԥ٥ȥΤȤmedian_col(X) 
 *      Ƥʬͤ롣
 *
 *  
 *      >> Y = median_col([[1 2][3 4][5 6]])
 *      === [Y] : (  1,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  3.00000000E+00  4.00000000E+00
 *
 *      >> Y = median_col([1 2 3])
 *      === [Y] : (  1,  1) ===
 *                 (  1)     
 *      (  1)  2.00000000E+00
 *
 *  ڴϢܡ
 *      median, median_row
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      median_row() - ʬ
 *
 *  ڷ
 *      Y = median_row(X)
 *         (Matrix|Array|Index) Y;
 *         (Matrix|Array|Index) X;
 *
 *  ڵǽ
 *      median_row(X)ϡʬͤᡤ٥ȥ֤
 *
 *      X ٥ȥޤϹԥ٥ȥΤȤmedian_row(X) 
 *      Ƥʬͤ롣
 *
 *  
 *      >> Y = median_row([[1 2 3][4 5 6]])
 *      === [Y] : (  2,  1) ===
 *                 (  1)     
 *      (  1)  2.00000000E+00
 *      (  2)  5.00000000E+00
 *
 *      >> Y = median_row([[1][2][3]])   
 *      === [Y] : (  1,  1) ===
 *                 (  1)     
 *      (  1)  2.00000000E+00
 *
 *  ڴϢܡ
 *      median, median_col
 */


Func Real median(x)
	Matrix x;
{
	Matrix y;

	y = median_col(x);

	if (length(y) == 1) {
		return y(1,1);
	} else {
		return [median_col(y)](1,1);
	}
}

Func Matrix median_col(x_)
	Matrix x_;
{
	Integer i,m,n;
	Matrix x,y,xx;

	x = x_;

	{m,n} = size(x);

	if (m == 1) {
		// ԥ٥ȥ
		{x} = sort(x);
		if (rem(n,2)) {		// n ϴ
			y = [x((n+1)/2)];
		} else {			// n ϶
			y = [(x(n/2) + x(n/2+1))/2];
		}
	} else {
		for (i = 1; i <= n; i++) {
			{xx} = sort(x(:,i));
			x(:,i) = xx;
		}

		if (rem(m,2)) {		// m ϴ
			y = x((m+2)/2,:);
		} else {			// m ϶
			y = (x(m/2,:) + x(m/2+1,:))/2;
		}
	}
	return y;
}

Func Matrix median_row(x)
	Matrix x;
{
	return trans(median_col(trans(x)));
}
