
/*  -*- MaTX -*-
 *
 *  ̾
 *      unwrap() - Ѥν
 *
 *  ڷ
 *      Y = unwrap(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  ڵǽ
 *      Y = unwrap(X) ϡͤѲ PI 礭ȤϢ³
 *      뤿ᡤ+- 2 PI ܲäƹ X ʬ롣X 
 *      ʬϡ鱦夫鲼ءȤ롣Y = unwrap(X, cutoff)
 *      ϡͤΰѲ cuffoff 礭Ȥ򤹤롣
 *      cutoff ٤ǻꤹ롣
 *
 *      unwrap() Ǥ뤬ǡʤǡ޷Ѳ
 *      ̤ʤȤ롣
 * 
 *  
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = 1/(s^3 + 2*s^2 + 3*s + 4);
 *      >> data = eval(G, j*w);
 *      >> p = unwrap(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p);
 *
 *  ڴϢܡ
 *      unwrap_row, unwrap_col
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      unwrap_col() - ΰѤν
 *
 *  ڷ
 *      Y = unwrap_col(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap_col(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  ڵǽ
 *      Y = unwrap_col(X) ϡͤѲ PI 礭ȤϢ
 *      ³뤿ᡤ+- 2 PI ܲäƥ٥ȥ X ʬ롣
 *      Y = unwrap_col(X, cutoff)ϡͤΰѲ cuffoff 
 *      Ȥ򤹤롣cutoff ٤ǻꤹ롣
 *
 *      X ΤȤ˰Ѥ롣Y  X Ʊ礭ˤʤ롣
 *
 *      unwrap_col() Ǥ뤬ǡʤǡ޷Ѳ
 *      ̤ʤȤ롣
 * 
 *  
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = [1/(s^3 + 2*s^2 + 3*s + 4), 1/(s+1)];
 *      >> data = eval(G, j*w');
 *      >> p = unwrap_col(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p');
 *
 *  ڴϢܡ
 *      unwrap, unwrap_row
 *
 *   ------------------------------------------------------------------------
 *
 *  ̾
 *      unwrap_row() - ΰѤν
 *
 *  ڷ
 *      Y = unwrap_row(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap_row(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  ڵǽ
 *      Y = unwrap_row(X) ϡͤѲ PI 礭ȤϢ
 *      ³뤿ᡤ+- 2 PI ܲäƥ٥ȥ X ʬ롣
 *      Y = unwrap_row(X, cutoff)ϡͤΰѲ cuffoff 
 *      Ȥ򤹤롣cutoff ٤ǻꤹ롣
 *
 *      X ΤȤ˰Ѥ롣Y  X Ʊ礭ˤʤ롣
 *
 *      unwrap_row() Ǥ뤬ǡʤǡ޷Ѳ
 *      ̤ʤȤ롣
 * 
 *  
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = [[1/(s^3 + 2*s^2 + 3*s + 4)][1/(s+1)]];
 *      >> data = eval(G, j*w);
 *      >> p = unwrap_row(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p);
 *
 *  ڴϢܡ
 *      unwrap, unwrap_col
 */


Func Array unwrap(ph, tol, ...)
	Array ph;
	Real tol;
{
	Array x;
	Integer m, n;

	error(nargchk(1, 2, nargs, "unwrap"));

	m = Rows(ph);
	n = Cols(ph);
	
	if (nargs == 1) {
		if (m == 1 || n == 1) {
			return unwrap_col(ph);
		} else {
			x = unwrap_col(reshape(ph, m*n, 1));
			return reshape(x, m, n);
		}
	} else {
		if (m == 1 || n == 1) {
			return unwrap_col(ph, tol);
		} else {
			x = unwrap_col(reshape(ph, m*n, 1), tol);
			return reshape(x, m, n);
		}
	}
}

Func Array unwrap_row(ph, tol, ...)
	Array ph;
	Real tol;
{
	error(nargchk(1, 2, nargs, "unwrap_row"));
	
	if (nargs == 1) {
		return trans(unwrap_col(trans(ph)));
	} else {
		return trans(unwrap_col(trans(ph), tol));

	}
}

Func Array unwrap_col(ph_, tol, ...)
	Array ph_;
	Real tol;
{
	Integer i,j,k,m,mo,no,n;
	Array ph,ph2,p,pd;
	Index idx;

	error(nargchk(1, 2, nargs, "unwrap_col"));

	if (nargs == 1) {
		tol = PI*170./180.;    // Ƹ
	}

	ph = ph_;

	{m,n} = size(ph);
	mo = m;
	no = n;
	if (mo < no) {
		ph = trans(ph);
		{m,n} = size(ph);
	}

	ph2 = ph;

	for (j = 1; j <= n; j++) {
		p = ph(:,j);
		pd = diff(p);
		idx = find(abs(pd) > tol);
		for (i = 1; i <= length(idx); i++) {
			k = idx(i);
			p(k+1:m) = p(k+1:m) .- 2*PI*sgn(pd(k));
		}
		ph2(:,j) = p;
	}

	if (mo < no) {
		ph2 = trans(ph2);
	}
	return ph2;
}
